Subject: Re: [PATCH] Documentation: update git-pull.txt for clone's new default behavior

From: Luben Tuikov <[email-masked]>
Date: Tue, 2 Jan 2007 10:39:05 -0800 (PST)

--- Junio C Hamano <[email-masked]> wrote:
> Luben Tuikov <[email-masked]> writes:
> 
> > It is in this sense that I do "cd <branch>; git-pull . <branch>"
> > in a sequence, and I'd rather do "cd <branch>; git-pull <symbolic-ref>"
> > to define which branch is the merge coming from given the current branch
> > _and_ the symbolic ref.
> 
> If I am reading you correctly, you have multiple directories,
> each with its own .git/ directory but major parts of these .git/
> directories are shared (namely, objects/ and refs/).  You would
> not be able to have separate checkout in these directories if
> you shared .git/HEAD and .git/index, so at least each of these
> directories has these two files for its own.
> 
> Is that what you are doing?

Yes, but the _ONLY_ thing which is NOT shared is .git/HEAD and
.git/index.  EVERYTHING else is the _same_ in all branch-per-directory.

> If that is the case, I think you do not even have to have the
> "branch spec" to express the patchflow among them.  Essentially
> you are using "one branch, one directory, one repository"
> workflow (my understanding is that this is how BK worked but I
> haven't seen it) but with your own improvements.  The reason
> this is an improvement is because such a shared .git/refs/
> allows you to do diff and log across branches this way, so if
> you have a separate .git/config just like you already have
> separate .git/HEAD and .git/index in these directories, you can
> use [remote "xyz"] sections in each of them to achieve what you
> called 'symbolic'.

Yeah, but I do not want to introduce yet another non-shared
file -- namely the config.

I want the config to be shared as well, since the repo is
exactly the same.  Firthermore, the branches are branches of
the same repo, not of different one.  config should be one
and the same -- per repo.

   Luben